
/*     *******************************************************************************
	XVisual GUI Development System for Linux/X-Window
	Copyright (C) 1996 Steve Carrie.

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
        ******************************************************************************* */

/* =============================================
	xvis user interface builder for Athena widgets using
	xv class library.

	xvisEvent segment

	V1.0BETA  - last edited 25/06/96
    ============================================= */

// ---------------------------------------------
// Local Include file declarations

#include "xvis.h"
#include <string.h>
#include <stdio.h>

int tindex=0;

// ---------------------------------------------
// Local Forward Function declarations

int findEventToggle(String name);

// ---------------------------------------------
// Local Callbacks

void func_killcode_yes(Widget aw, XtPointer client, XtPointer call)
{
	alert.Close();
	delete objects[prop_object_index].eventcode[tindex];
	objects[prop_object_index].eventcode[tindex]=NULL;
}

void func_killcode_no(Widget aw, XtPointer client, XtPointer call)
{
	alert.Close();
}

void func_eventselect(Widget aw, XtPointer client, XtPointer call)
{
	char *togname;
	Boolean tstate=FALSE;

	XtVaGetValues(aw, XtNradioData, &togname, NULL);
	XtVaGetValues(aw, XtNstate, &tstate, NULL);
	tindex=findEventToggle(togname);
	
	if (tstate==0) {
		objects[prop_object_index].events=(objects[prop_object_index].events ^
			eventinfo[tindex].eventbits);
		if (objects[prop_object_index].eventcode[tindex]  !=NULL) {
			alert.init("Disable Event", xvisControl, 
				"There is code for this event\n Do you want to delete it?",
				XVMSGSIMPLECHOICE, "green",
				func_killcode_yes, func_killcode_no);
			alert.Open();
		}
	}
	else
		objects[prop_object_index].events=(objects[prop_object_index].events | 
			eventinfo[tindex].eventbits);
}

// ---------------------------------------------
// Local Functions

void buildEventsWindow()
{
	xvisEvents.init("Events", "xvisEvents", xvisContext);
 	xvisEvents.SetWindowResource(XtNiconPixmap, 
		xvisEvents.SetPixmapInfo(xvis_xpm, NULL));
	xvisEvents.SetBackground("gray70");
	xvisEvents.SetWindowResource(XtNgeometry, (XtArgVal)"+150+220");
	xvisEvents.SetWindowResource(XtNmaxWidth, 126);
	xvisEvents.SetWindowResource(XtNmaxHeight, 388);
	xvisEvents.SetWindowResource(XtNminWidth, 126);
	xvisEvents.SetWindowResource(XtNminHeight, 388);

	for (int i=0; i<NUMEVENTS; i++) {
		eventtoggles[i].init(eventinfo[i].eventName, xvisEvents, func_eventselect,
			eventinfo[i].eventName);
		eventtoggles[i].SetBackground("gray85");
		eventtoggles[i].SetDefaultDistance(0);
		eventtoggles[i].SetDistance(1,1);
		eventtoggles[i].ChangeFont("*times-*-r-*-120*");
		eventtoggles[i].SetWidth(125);
		eventtoggles[i].Off();
		eventtoggles[i].SetSensitive(FALSE);
		eventtoggles[i].SetFixedPosition(TRUE);
		eventtoggles[i].SetBeNiceToColormap(FALSE);
		eventtoggles[i].SetShadowWidth(4);
		if (i>0)
			eventtoggles[i].SetRelVertical(eventtoggles[i-1]);	
	}

	EventsVisible=TRUE;	
}

// ------------------------------------

void clearEventsData()
{
	for (int i=0; i<NUMEVENTS; i++)
		eventtoggles[i].Off();
}

// ------------------------------------

void setEventsData(unsigned long bits)
{
	for (int i=0; i<NUMEVENTS; i++)
		eventtoggles[i].State((bits & eventinfo[i].eventbits)!=0);
}

// ------------------------------------

void controlEventsData(Boolean sense)
{
	for (int i=0; i<NUMEVENTS; i++)
		eventtoggles[i].SetSensitive(sense);
	if (!sense) clearEventsData();
}

// ------------------------------------

int findEventToggle(String name)
{
	for (int i=0; i<NUMEVENTS; i++)
		if (strcmp(name, eventinfo[i].eventName)==0)
			return(i);
	return(-1);
}

// ------------------------------------			
