
/*     *******************************************************************************
	XVisual GUI Development System for Linux/X-Window
	Copyright (C) 1996 Steve Carrie.

        This program is free software; you can redistribute it and/or modify
        it under the terms of the GNU General Public License as published by
        the Free Software Foundation; either version 2 of the License, or
        (at your option) any later version.

        This program is distributed in the hope that it will be useful,
        but WITHOUT ANY WARRANTY; without even the implied warranty of
        MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
        GNU General Public License for more details.

        You should have received a copy of the GNU General Public License
        along with this program; if not, write to the Free Software
        Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
        ******************************************************************************* */

/* =============================================
	xvis user interface builder for Athena widgets using
	xv class library.

	Utils Segment

	V1.0BETA  - last edited 25/06/96
    ============================================= */

// ---------------------------------------------
// Include file declarations

#include "xvis.h"
#include <string.h>
#include <stdio.h>

//---------------------------------------------
// Local Stuff

objectType ToolNameToType(char *token)
{
	objectType obj=XVNone;

	for (int i=0; i<MAXTOOLS; i++)
		if (strcmp(token, objectName[i])==0) {
			obj=objectList[i];
			break;
		}

	return(obj);
}			

// -------------------------------------------
// Find Object by name

int ObjectByName(String name)
{
	int i=-1;
	for (int j=0; j<MAXOBJECTS; j++)
		if (strcmp(name, objects[j].name)==0) {
			i=j;
			break;
		}
	return(i);
}

// --------------------------------------------
// find first available slot in struct member

int firstAvailableSlot()
{
	int thisone=-1;

	for (int i=0; i<MAXOBJECTS; i++)
		if (objects[i].object_type == XVNone) {
			thisone=i;
			break;
		}

	return(thisone);
}

// ----------------------------------------
// Set total object count value
//
void SetCounterValue()
{
	sprintf(countvalue, "Objects : %d", nobject);
	xvisCount.SetLabel(countvalue);
}

// ----------------------------------------
// find first entry in project list.
//
int findFirstProjectEntry(int which)
{
	int thisone=-1;

	for (int i=0; i<MAXPROJECTFILES; i++)
		if (project_list[i] == which) {
			thisone=i;
			break;
		}

	return(thisone);
}

// ------------------------------------------		
// Convert string to pixel!

Pixel stringToPixel(xvCore & object, String colname)
{
	XrmValue from, to;
	Pixel output;
	Boolean testx;

	from.addr=colname;
	from.size=strlen(colname);

	to.addr=(char *) &output;
	to.size=sizeof(Pixel);

	testx=XtConvertAndStore(object.ID(), XtRString, &from, XtRPixel, &to);

	if (testx) 
		return(output);	
	else
		return((Pixel) -1);
}

// ----------------------------------------
// find first entry in editcontrol list.
//
int findFirstEditEntry()
{
	int thisone=-1;

	for (int i=0; i<MAXEDITWINDOWS; i++)
		if (! editor[i].in_use) {
			thisone=i;
			break;
		}

	return(thisone);
}

// ----------------------------------------
// find first entry in modulecontrol list.
//
int findFirstModuleEntry()
{
	int thisone=-1;

	for (int i=0; i<MAXEDITWINDOWS; i++)
		if (! module[i].in_use) {
			thisone=i;
			break;
		}

	return(thisone);
}

// -------------------------------------------

Boolean UnsavedData()
{
	Boolean nosave=FALSE;

	for (int i=0; i<MAXOBJECTS; i++)
		if ((objects[i].object_type==XVWindow) && (objects[i].changed))
			nosave=TRUE;

	for (int i=0; i<MAXEDITWINDOWS; i++)
		if ((module[i].in_use) && (module[i].changed)) nosave=TRUE;

	return(nosave);
}

// ----------------------------------------------

void drawGrid(int obj)
{
	char colname[25];

	if (! showGrid) return;

	strcpy(colname, objects[obj].foreground_colour);
	if (strcmp(colname, "(default)")==0)
		strcpy(colname, "navy");

	objects[obj].pwindow->GCSetForeground(
		stringToPixel(*objects[obj].pwindow, colname));

	objects[obj].pwindow->GCSetFunction(GXcopy);

	for (int x=0; x<objects[obj].winwidth+gridX; x+=gridX)
		for (int y=0; y<objects[obj].winheight+gridY; y+=gridY)
			objects[obj].pwindow->GDrawPoint(x, y);
}

// ----------------------------------------------
